{The Jstrings unit was written originally in 1987 for Turbo Pascal by me
Jem Miller @Missing Link Software.
This unit is licensed under the WTF license. Do WTF you want with it. Burn
it, give it away, make millions with it, or throw darts at it. I still use
this sucker in virtually all of my work.
jem@mlsoft.org
}
unit Jstr32;
{$mode objfpc}{$H+}

interface
uses sysutils;

type
    stype = string;
    sstr = string[80];

var
   tpferror : byte;

{ String routines }
function B2Hex(numb : byte): sstr; //byte to hex
function N2Hex(numb : word): sstr; //number(integer/word to hex
function L2Hex(L : longint): sstr; //longint to hex
function copies(s : char; nm : byte) : string; //returns nm S's as a string
Function proper(Switch : String) : String; //returns a string with first letter of each word capitolized
function words(str : string) : byte; //returns the number of words in str
function wordn(str : string; nm : byte) : string; //returns word number nm in str
{ routines that are partially assembly written } //not anymore!

function trim(str : string) : string; //trims spaces from the end of str
function tab(n : integer) : string; //inserts n spaces in a string
function stripto(var st : string; schar : char) : string; //strips all chars up to and including schar from beginning of a string
function strip(sline : stype; schar : char): string; //removes all occurences of schar from a string
function stripit(str : string; src: string) : string; //strips a string src from the string str. string version of strip
function replace(sline : stype; schar,rchar : char): string; //replaces rchar with schar in sline
Function I2Str(Number : longint) : string; //converts integer to string
Function S2Rl(Str : string) : real; //converts string to real
function Rl2str(Number : real; Decimals : byte): string; //converts real to string
Function S2Int(Str : string) : integer; //converts string to integer
Function S2Ln(Str : string) : Longint; //converts string to longint
Function PadLeft(Str : string; Size : byte; Pad : char) : string; //pads beginning of str with size pad chars
Function PadCenter(Str : string; Size : byte; Pad : char) : string; //pads both ends of str with size pad chars
Function PadRight(Str : string; Size : byte; Pad : char) : string;//pads the right end of str with size pad chars
Function First_Capital_Pos(Str : string) : byte; //returns position of first capital letter in str
Function First_capital(Str : string) : char; //returns first capitol letter in str
Function Last(N : byte; Str : string) : string; //returns last N chars from str
Function First(N : byte; Str : string) : string; //returns first N chars from str
Function Upper(Str : string) : string; //converts str to all uppercase
Function Lower(Str : string) : string; //converts str to all lowercase
function OverType(N : byte; StrS, StrT : string) : string;
Function LastPos(C : Char; Str : string) : byte; //returns last position of C in str
Function LocWord(StartAT, Wordno : byte; Str : string) : byte; //returns location of word wordno in str beginning at startat
Function PosWord(Wordno : byte; Str : string) : byte; //returns position of word number wordno in str
Function WordCnt(Str : string) : byte; //returns number of words in str
Function GetWords(StartWord, NoWords : byte; Str : string) : string; //returns nowords words starting at startword in str
function unique : string; //returns a unique string based on date, time, and milliseconds in hexadecimal
function mirt(name : string) : string; //trims spaces from the beginning of a string

implementation

CONST
    Floating = 255;

{ ------------------------------------------------------------------------- }

function B2Hex(numb : byte): sstr;       { Converts byte to hex string }
const
    HexChars : array[0..15] of char = '0123456789ABCDEF';
begin
    B2Hex[0]:= #2;
    B2Hex[1]:= HexChars[numb shr  4];
    B2Hex[2]:= HexChars[numb and 15];
end; { Byte2Hex }

function N2Hex(numb: word): sstr;        { Converts word to hex string.}
begin
    N2Hex:= B2Hex(hi(numb))+B2Hex(lo(numb));
end; { Numb2Hex }

function L2Hex(L : longint): sstr;     { Converts longint to hex string }
begin
    L2Hex:= N2Hex(L shr 16) + N2Hex(L);
end; { Long2Hex }

function unique : string;
Var h,m,s,ms     : Word;
    yr,mo,da : Word;
    present : tdatetime;
    WrkStr       : String;
    ll : longint;

Begin
  WrkStr:= '';
  present:= now;
  decodetime(present,h,m,s,ms);

  decodedate(present,yr,mo,da);

  WrkStr:= i2str(mo)
           +i2str(da)
           +i2str(h)
           +i2str(m)
           +i2str(s);

  ll:= s2int(wrkstr);

  wrkstr:= l2hex(ll);

  result:= wrkstr;

end;

function mirt(name : string) : string;
var
   st : string;
   a : integer;

begin
   a:= 1;

   if name = '' then
   exit;

   while (name[a] > #32) and (name[a] < #128) do
   inc(a);

   st:= copy(name,a + 1,length(name));

   result:= st;
end;

function copies(s : char; nm : byte) : string;
var
   st : string;
   a : byte;

begin

   st:= '';

   for a:= 1 to nm do
   st:= st+s;

   copies:= st;
end;

Function PadLeft(Str : string; Size : byte; Pad : char) : string;
var temp : string;
begin
     temp:= '';
    Fillchar(Temp[1], Size, Pad);
    setlength(Temp, Size);

    If Length(Str) <= Size then
       Move(Str[1], Temp[1], length(Str))
    else
       Move(Str[1], Temp[1], size);

    PadLeft:= Temp;
end;

Function PadCenter(Str : string; Size : byte; Pad : char) : string;
var temp : string;
L : byte;
begin
     temp:= '';
    Fillchar(Temp[1], Size,Pad);
    setlength(Temp, Size);
    L:= length(Str);

    If L <= Size then
       Move(Str[1], Temp[((Size - L) div 2) + 1], L)
    else
       Move(Str[((L - Size) div 2) + 1], Temp[1], Size);

    PadCenter:= temp;
end; {center}

Function PadRight(Str:string;Size : byte; Pad : char):string;
var
  temp : string;
  L : integer;
begin
    Temp:= copies(pad, Size);
    L:= length(Str);

    If L <= Size then
       Move(Str[1], Temp[succ(Size - L)],L)
    else
       Move(Str[1], Temp[1],size);

    PadRight:= Temp;
end;

function tab(n : integer) : string;
begin
     tab:= copies(' ',n);

end;

function stripto(var st : string; schar : char) : string;
var
   a : byte;

begin

            a:= pos(schar, st);

            if a <> 0 then
            begin
            stripto:= copy(st, 1, a-1);
            delete(st, 1, a);
            end
            else
            begin
            stripto:= st;
            st:= '';
            end;

end;

Function proper(Switch : String) : String;
Var
  NextUp : Boolean;
  n : integer;

Begin
  switch:= lowercase(switch);
  NextUp := True;

  For N:= 1 to Length(switch) do
  Begin
    If NextUp = True then
    switch[N]:= UpCase(switch[N]);

    If Switch[N] in ['!','@','#','$','%','^','&','*','(',')','-','_','=','+',
    '[','{',']','}',';',':','''','"','`','~','\','|',',','<','.','>','/','?',
    ' '] then
    NextUp:= True
    else
    NextUp:= False;
  End;

  proper:= Switch;

End;

function words(str : string) : byte;

var
   wc,
   n : byte;
   nextup : boolean;

begin
   wc:= 0;

  NextUp:= True;

  For N:= 1 to Length(str) do
  Begin
    If NextUp = True then
    inc(wc);

    If Str[N] in ['!','@','#','$','%','^','&','*','(',')','-','_','=','+',
    '[','{',']','}',';',':','''','"','`','~','\','|',',','<','.','>','/','?',
    ' '] then
    NextUp:= True
    else
    NextUp:= False;
  End;

   words:= wc;

end;

function wordn(str : string; nm : byte) : string;

var
   wc,
   a,b,n,r : byte;

begin
   wc:= 0;
   n:= 1;
   a:= 0;
   r:= 0;

   if str = '' then
   begin
   result:= '';
   exit;
   end;

  while N <= Length(str) do
  Begin

    if wc = nm then
    break;

    If Str[N] in ['0'..'9','A'..'Z','a'..'z'] then
    begin
    a:= n;

    for b:= n+1 to length(str) do
    if not (str[b] in ['0'..'9','A'..'Z','a'..'z']) then
    begin
    n:= b-1;
    r:= b-a;
    inc(wc);
    break;
    end;

    if b > length(str) then
    begin
    n:= b-1;
    r:= b-a;
    inc(wc);
    end;

    end;

  inc(n);
  End;

  if wc < nm then
  begin
  result:= '';
  exit;
  end;

  result:= copy(str, a, r);

end;

function strip(sline : stype; schar : char): string;

var
   a : byte;

begin

         a:= pos(schar, sline);

         while a <> 0 do
         begin
         delete(sline, a, 1);
         a:= pos(schar, sline);
         end;

         strip:= sline;

end;

function stripit(str : string; src: string) : string;
var
   a : byte;

begin

         a:= pos(src, str);

         while a <> 0 do
         begin
         delete(str, a, length(src));
         a:= pos(src, str);
         end;

         result:= str;

end;

function replace(sline : stype; schar, rchar : char): string;

var
   a : byte;

begin

         a:= pos(schar, sline);

         while a <> 0 do
         begin
         delete(sline, a, 1);
         insert(rchar, sline, a);
         a:= pos(schar, sline);
         end;

         replace:= sline;

end;

Function I2Str(Number : longint):string;
var Temp : string;
begin
    Str(Number, temp);
    I2Str:= temp;
end;

Function S2Rl(Str:string):real;
var
  code : integer;
  Temp : real;
begin
    If length(Str) = 0 then
       S2Rl:= 0
    else
    begin
        if copy(str, 1, 1) = '$' then
        delete(str, 1, 1);

        If Copy(Str, 1, 1) = '.' Then
           Str:= '0' + Str;

        If (Copy(Str, 1, 1) = '-') and (Copy(Str, 2, 1) = '.') Then
           Insert('0', Str, 2);

        If Str[length(Str)] = '.' then
           Delete(Str, length(Str), 1);

       val(Str, temp, code);

       if code = 0 then
          S2Rl:= temp
       else
          S2Rl:= 0;
    end;
end;

function Rl2str(Number : real; Decimals : byte) : string;
var Temp : string;
begin
    Str(Number:20:Decimals, Temp);

    repeat
         If copy(Temp, 1, 1) = ' ' then delete(Temp, 1, 1);
    until copy(temp, 1, 1) <> ' ';

    If Decimals = Floating then
    begin
       Temp := Strip(temp, '0');

       If Temp[Length(temp)] = '.' then
          Delete(temp,Length(temp), 1);
    end;

    Rl2Str := Temp;
end;

Function  S2Int(Str : string) : integer;
var temp,code : integer;
begin
    If length(Str) = 0 then
       S2Int := 0
    else
    begin
       val(Str,temp,code);

       if code = 0 then
          S2Int:= temp
       else
          S2Int:= 0;
    end;
end;

Function S2Ln(Str : string) : Longint;
var
  code : integer;
  Temp : longint;
begin
    If length(Str) = 0 then
       S2Ln:= 0
    else
    begin
       val(Str, temp, code);

       if code = 0 then
          S2Ln:= temp
       else
          S2Ln:= 0;
    end;
end;


function trim(str : string) : string;

var
   ln : byte;

begin

         ln:= length(str);

         while str[ln] = #32 do
         dec(ln);

         setlength(str, ln);
         trim:= str;

end;

Function First_Capital_Pos(Str : string): byte;
 {}
 var StrPos : byte;
 begin
     StrPos:= 1;

     While (StrPos <= length(Str))  and ((Str[StrPos] in ['A'..'Z']) = false) do
            StrPos:= Succ(StrPos);

     If StrPos > length(Str) then
        First_Capital_Pos:= 0
     else
        First_Capital_Pos:= StrPos;
 end; {of func First_Capital_Pos}

Function First_capital(Str : string): char;
 {}
 var B : byte;
 begin
     B:= First_Capital_Pos(Str);

     If B > 0 then
        First_Capital:= Str[B]
     else
        First_Capital:= #0;
 end; {of func First_capital}

Function Last(N : byte; Str : string) : string;
var Temp : string;
begin
    If N > length(Str) then
       Temp:= Str
    else
       Temp:= copy(Str, succ(length(Str) - N), N);

    Last:= Temp;
end;  {Func Last}

Function First(N : byte; Str : string) : string;
var Temp : string;
begin
    If N > length(Str) then
       Temp:= Str
    else
       Temp:= copy(Str, 1, N);

    First:= Temp;
end;  {Func First}

Function Upper(Str : string) : string;
var
  I : integer;
begin
    if str = '' then
    exit;
    
    For I:= 1 to length(Str) do
        Str[I]:= Upcase(Str[I]);

    Upper:= Str;
end;  {Func Upper}

Function Lower(Str : string) : string;
var
  I : integer;
begin
    For I:= 1 to length(Str) do
        If ord(Str[I]) in [65..90] then
           Str[I]:= chr(ord(Str[I]) + 32);

    Lower:= Str;
end;  {Func Lower}

function OverType(N : byte; StrS, StrT : string) : string;
{Overlays StrS onto StrT at Pos N}
var
  L : byte;
  StrN : string;
begin
    L:= N + pred(length(StrS));

    If L < length(StrT) then
       L:= length(StrT);

    If L > 254 then
       Overtype:= copy(StrT,1,pred(N)) + copy(StrS,1,255-N)
        else
    begin
       StrN:= '';
       Fillchar(StrN[1], L, ' ');
       setlength(StrN, L);

       Move(StrT[1], StrN[1], length(StrT));
       Move(StrS[1], StrN[N], length(StrS));
       OverType:= StrN;
    end;

end;  {Func OverType}

Function LastPos(C : Char; Str : string) : byte;
Var I : byte;
begin
    I:= succ(Length(Str));
    Repeat
         I:= Pred(I);
    Until (I = 0) or (Str[I] = C);

    LastPos:= I;
end;  {Func LastPos}

Function LocWord(StartAT, Wordno : byte; Str : string) : byte;
{local proc used by PosWord and Extract word}
var
  W: integer;
  Spacebefore: boolean;
begin
    If (Str = '') or (wordno < 1) or (StartAT > length(Str)) then
    begin
        LocWord:= 0;
        exit;
    end;

    SpaceBefore:= true;
    W:= 0;
    StartAT:= pred(StartAT);

    While (W < Wordno) and (StartAT <= length(Str)) do
    begin
        StartAT:= succ(StartAT);
        If SpaceBefore and (Str[StartAT] <> ' ') then
        begin
            W:= succ(W);
            SpaceBefore:= false;
        end
        else
            If (SpaceBefore = false) and (Str[StartAT] = ' ') then
                SpaceBefore:= true;
    end;

    If W = Wordno then
       LocWord:= StartAT
    else
       LocWord:= 0;

end;

Function PosWord(Wordno : byte; Str : string) : byte;
begin
    PosWord:= LocWord(1, wordno, Str);
end;  {Func Word}

Function WordCnt(Str : string) : byte;
begin
    WordCnt:= Words(str);
end;

Function GetWords(StartWord, NoWords : byte; Str : string) : string;
var Start, finish : integer;
begin
    If Str = '' then
    begin
        GetWords:= '';
        exit;
    end;

    Start := LocWord(1, StartWord, Str);

    If Start <> 0 then
       finish:= LocWord(Start, succ(NoWords), Str)
    else
    begin
        getwords:= '';
        exit;
    end;

    If finish = 0 then {5.02A}
       finish:= succ(length(Str));
    Repeat
        finish:= pred(finish);
    Until Str[finish] <> ' ';

    getWords:= copy(Str, Start, succ(finish-Start));
end;  {Func getwords}

end.
